//----------------------------------------------------------------------//
// NyanFi																//
//  fBNg̔r_CAO										//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include "Global.h"
#include "UserFunc.h"
#include "UserMdl.h"
#include "DiffDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDiffDirDlg *DiffDirDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TDiffDirDlg::TDiffDirDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDiffDirDlg::FormCreate(TObject *Sender)
{
	set_ComboBox_AutoComp(this);

	DiffMaskComboBox->Tag	= CBTAG_HISTORY;
	DiffExcDirComboBox->Tag = CBTAG_HISTORY;

	UnicodeString hntstr = LoadUsrMsg(USTR_HintMltSepSC);
	DiffExcDirComboBox->Hint = hntstr;
	DiffMaskComboBox->Hint	 = hntstr;
}
//---------------------------------------------------------------------------
void __fastcall TDiffDirDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	IniFile->LoadComboBoxItems(DiffMaskComboBox,	_T("DiffIncMaskHistory"));
	IniFile->LoadComboBoxItems(DiffExcDirComboBox,	_T("DiffExcDirHistory"));

	DiffMaskComboBox->Text	 = IniFile->ReadStrGen(_T("DiffIncMask"), "*.*");
	DiffExcDirComboBox->Text = IniFile->ReadStrGen(_T("DiffExcDir"));
	SubDirCheckBox->Checked  = IniFile->ReadBoolGen(_T("DiffSubDir"));

	DiffMaskComboBox->SetFocus();
	DiffMaskComboBox->SelStart = DiffMaskComboBox->Text.Length();
}
//---------------------------------------------------------------------------
void __fastcall TDiffDirDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SavePosInfo(this);

	if (ModalResult==mrOk) {
		if (DiffMaskComboBox->Text.IsEmpty()) DiffMaskComboBox->Text = "*.*";
		add_ComboBox_history(DiffMaskComboBox,		DiffMaskComboBox->Text);
		add_ComboBox_history(DiffExcDirComboBox,	DiffExcDirComboBox->Text);
	}

	IniFile->SaveComboBoxItems(DiffMaskComboBox,	_T("DiffIncMaskHistory"));
	IniFile->SaveComboBoxItems(DiffExcDirComboBox,	_T("DiffExcDirHistory"));

	IniFile->WriteStrGen(_T("DiffIncMask"),	DiffMaskComboBox->Text);
	IniFile->WriteStrGen(_T("DiffExcDir"),	DiffExcDirComboBox->Text);
	IniFile->WriteBoolGen(_T("DiffSubDir"),	SubDirCheckBox);
}

//---------------------------------------------------------------------------
void __fastcall TDiffDirDlg::StartActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = true;

	DiffExcDirComboBox->Color	= SubDirCheckBox->Checked? scl_Window : col_Invalid;
}

//---------------------------------------------------------------------------
void __fastcall TDiffDirDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift, _T(HELPTOPIC_FL) _T("#DiffDir"));
}
//---------------------------------------------------------------------------

